unit f_SaveLoadChartTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls, Vcl.Menus,
  VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart, vclTee.series;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    PrintSetup1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    master: TChart;
    Splitter1: TSplitter;
    clone: TChart;
    dOpen: TOpenDialog;
    dSave: TSaveDialog;
    Edit1: TMenuItem;
    CopyAssign1: TMenuItem;
    CopyClone1: TMenuItem;
    CopyStream1: TMenuItem;
    N3: TMenuItem;
    Clear1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure CopyAssign1Click(Sender: TObject);
    procedure CopyClone1Click(Sender: TObject);
    procedure CopyStream1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    ser: TLineSeries;
    procedure InitChart;
  public
  end;

var
  Form1: TForm1;

implementation
uses vcltee.teestore;
{$R *.dfm}

procedure TForm1.Clear1Click(Sender: TObject);
begin
  clone.ClearChart;
end;

procedure TForm1.CopyAssign1Click(Sender: TObject);
begin
  clone.Assign(master);
end;

procedure TForm1.CopyClone1Click(Sender: TObject);
begin
  CloneChart(clone, master, self, FALSE);
end;

procedure TForm1.CopyStream1Click(Sender: TObject);
var
  strm: TMemoryStream;
begin
  strm:= TMemoryStream.Create;
  try
    SaveChartToStream(master, strm, TRUE, TRUE);
    strm.Position:= 0;
    try
      LoadChartFromStream(clone, strm);
      clone.Title.Text.Text:= 'Copy of ' + clone.Title.Text.Text;
    except
      ShowMessage('Failed to load:'#13 + dOpen.FileName);
    end;
  finally
    strm.Free;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitChart;
  dOpen.InitialDir:= ExtractFilePath(paramstr(0));
  dSave.InitialDir:= dOpen.InitialDir;
  RegisterClass(TLineSeries);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
//
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  master.Width:= self.ClientWidth div 2;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
//  clone.Width:= self.clientwidth div 2;
end;

procedure TForm1.InitChart;
var
  ax, hax: TChartAxis;
begin
  master.serieslist.clear;
  master.CustomAxes.Clear;
  ax:= TChartAxis.Create(master);
  ax.Horizontal:= TRUE;
  ax.StartPosition:= 25;
  ax.EndPosition:= 75;
  ax.PositionPercent:= 25;
  ax.Title.Text:= 'Custom Horizontal';
  hax:= ax;
  ax:= TChartAxis.Create(master);
  ax.StartPosition:= 25;
  ax.EndPosition:= 75;
  ax.PositionPercent:= 25;
  ax.Title.Text:= 'Custom Vertical';
{ this causes stack overflow in syste.UnicodeFromLocakleChars!
  ax.PartnerAxis:= hax;
  ax.UsePartnerAxis:= TRUE;
  hax.PartnerAxis:= ax;
  hax.UsePartnerAxis:= TRUE;
{}

  ser:= TLineSeries.Create(master);
  ser.CustomHorizAxis:= master.CustomAxes[0];
  ser.CustomvertAxis:=  master.CustomAxes[1];
  ser.FillSampleValues(1000);
  master.AddSeries(ser);
  ser:= TLineSeries.Create(master);
  ser.FillSampleValues(1000);
  master.AddSeries(ser);
  ser.CustomHorizAxis:= master.CustomAxes[0];
  ser.CustomvertAxis:=  master.CustomAxes[1];
{
  ser:= TLineSeries.Create(master);
  ser.FillSampleValues(1000);
  master.AddSeries(ser);
  ser:= TLineSeries.Create(master);
  ser.FillSampleValues(1000);
  ser.VertAxis:= aRightAxis;
  master.AddSeries(ser);
  master.BottomAxis.Title.Text:= 'Horizontal';
  master.LeftAxis.Title.Text:= 'Left vertical';
  master.RightAxis.Title.Text:= 'Right vertical';
  master.Title.Text.Text:= 'Test for Load/Save/Copy'#13'Multiline title'
}
end;


procedure TForm1.New1Click(Sender: TObject);
begin
  InitChart;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if dOpen.Execute then begin
    clone.Perform(wm_setredraw, 0, 0);
    try
      LoadChartFromFile(clone, dOpen.FileName);
    finally
      clone.Perform(wm_setredraw, 1, 0);
      clone.Repaint;
    end;
  end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
  s, ss: string;
begin
  if dSave.execute then begin
    s:= dSave.FileName;
    ss:= ExtractFileExt(s);
    if ss = '' then begin
      s:= s + dSave.DefaultExt;
    end;
    SaveChartToFile(master, dSave.FileName, TRUE, TRUE);
  end;
end;

end.
